Index: /trunk/src/sh_hash.c
===================================================================
--- /trunk/src/sh_hash.c	(revision 584)
+++ /trunk/src/sh_hash.c	(revision 1)
@@ -1191,59 +1896,55 @@
 extern int sh_util_hextobinary (char * binary, char * hex, int bytes);
 
-char * sh_hash_db2pop (const char * key, struct store2db * save)
-{
+char * sh_hash_db2pop (char * key, unsigned long * val1, 
+		       unsigned long * val2, unsigned long * val3,
+		       int * size)
+{
+  file_type   tmpFile;
   size_t      len;
   char      * p;
   int         i;
-  char      * retval = NULL;
-  char        fileHash[KEY_LEN+1];
-  file_type * tmpFile = SH_ALLOC(sizeof(file_type));
-  
-  save->size = 0;
-
-  if (0 == sh_hash_get_it (key, tmpFile, fileHash))
-    {
-      save->val0 = tmpFile->size;
-      save->val1 = tmpFile->mtime;
-      save->val2 = tmpFile->ctime;
-      save->val3 = tmpFile->atime;
-
-      sl_strlcpy(save->checksum, fileHash, KEY_LEN+1);
-
-      if (tmpFile->link_path && tmpFile->link_path[0] != '-')
-	{
-	  len = strlen(tmpFile->link_path);
+
+  *size = 0;
+
+  if (0 == sh_hash_get_it (key, &tmpFile))
+    {
+      *val1  = tmpFile.size;
+      *val2 = tmpFile.mtime;
+      *val3 = tmpFile.ctime;
+
+      if (tmpFile.linkpath[0] != '-')
+	{
+	  len = strlen(tmpFile.linkpath);
 
 	  p = SH_ALLOC((len/2)+1);
-	  i = sh_util_hextobinary (p, tmpFile->link_path, len);
+	  i = sh_util_hextobinary (p, tmpFile.linkpath, len);
 
 	  if (i == 0)
 	    {
-	      save->size = (len/2);
-	      p[save->size] = '\0';
-	      retval = p;
+	      *size = (len/2);
+	      p[*size] = '\0';
+	      return p;
 	    }
 	  else
 	    {
 	      SH_FREE(p);
-	      save->size = 0;
+	      *size = 0;
+	      return NULL;
 	    }
 	}
       else
 	{
-	  save->size = 0;
-	}
-    }
-  else
-    {
-      save->size = -1;
-      save->val0 = 0;
-      save->val1 = 0;
-      save->val2 = 0;
-      save->val3 = 0;
-    }
-  if (tmpFile->link_path) SH_FREE(tmpFile->link_path);
-  SH_FREE(tmpFile);
-  return retval;
+	  *size = 0;
+	  return NULL;
+	}
+    }
+  else
+    {
+      *size = -1;
+      *val1 =  0;
+      *val2 =  0;
+      *val3 =  0;
+      return NULL;
+    }
 }
 
@@ -1258,38 +1959,28 @@
 sh_file_t * sh_hash_push_int (file_type * buf, char * fileHash)
 {
-  sh_file_t    * fp = NULL;
+  sh_file_t    * fp;
   sh_filestore_t p;
-
-  size_t len;
+  long i;
   char * fullpath;
   char * linkpath;
-  char * attr_string = NULL;
-  char hashbuf[KEYBUF_SIZE];
 
   SL_ENTER(_("sh_hash_push_int"));
 
-  if (!buf)
-    SL_RETURN(NULL, _("sh_hash_push_int"));
-    
   fp = SH_ALLOC(sizeof(sh_file_t));
 
   p.mark = REC_MAGIC;
-  if (buf->attr_string)
-    p.mark |= REC_FLAGS_ATTR;
   sl_strlcpy(p.c_mode,   buf->c_mode,   11);
   sl_strlcpy(p.c_group,  buf->c_group,  GROUP_MAX+1);
   sl_strlcpy(p.c_owner,  buf->c_owner,  USER_MAX+1);
   sl_strlcpy(p.checksum, fileHash,      KEY_LEN+1);
-#if defined(__linux__) || defined(HAVE_STAT_FLAGS)
+#if defined(__linux__)
   sl_strlcpy(p.c_attributes, buf->c_attributes, 13);
 #endif
 
-#if defined(__linux__) || defined(HAVE_STAT_FLAGS)
+#if defined(__linux__)
   p.attributes  = (UINT32) buf->attributes;
 #endif
   p.linkmode    = (UINT32) buf->linkmode;
   p.hardlinks   = (UINT32) buf->hardlinks;
-  p.dev   = (UINT64) buf->dev;
-  p.rdev  = (UINT64) buf->rdev;
   p.mode  = (UINT32) buf->mode;
   p.ino   = (UINT32) buf->ino;
@@ -1301,19 +1992,15 @@
   p.group = (UINT32) buf->group;
 
-  p.checkflags = (UINT32) buf->check_flags;
-
   memcpy( &(*fp).theFile, &p, sizeof(sh_filestore_t) );
-  fp->fflags    = 0;  /* init fflags */
+  fp->visited   = S_FALSE;
+  fp->reported  = S_FALSE;
+  fp->allignore = S_FALSE;
   fp->modi_mask = 0L;
 
-  if (buf->attr_string)
-    attr_string = sh_util_strdup(buf->attr_string);
-  fp->attr_string = attr_string;
-
-  len = sl_strlen(buf->fullpath);
-  if (len <= MAX_PATH_STORE) 
-    {
-      fullpath = SH_ALLOC(len+1);
-      sl_strlcpy(fullpath, buf->fullpath, len+1);
+  i = sl_strlen(buf->fullpath);
+  if (i <= MAX_PATH_STORE) 
+    {
+      fullpath = SH_ALLOC(i+ 1);
+      sl_strlcpy(fullpath, buf->fullpath, i+1);
     } 
   else 
@@ -1321,17 +2008,16 @@
       fullpath = SH_ALLOC(KEY_LEN + 1);
       sl_strlcpy(fullpath, 
-		 sh_tiger_hash (buf->fullpath, TIGER_DATA, len,
-				hashbuf, sizeof(hashbuf)), 
+		 sh_tiger_hash (buf->fullpath, TIGER_DATA, i), 
 		 KEY_LEN+1);
     }
   fp->fullpath  = fullpath;
 
-  if (buf->link_path)
+  if (buf->c_mode[0] == 'l')
     {  
-      len = sl_strlen(buf->link_path);
-      if (len <= MAX_PATH_STORE) 
-	{
-	  linkpath = SH_ALLOC(len+1);
-	  sl_strlcpy(linkpath, buf->link_path, len+1);
+      i = sl_strlen(buf->linkpath);
+      if (i <= MAX_PATH_STORE) 
+	{
+	  linkpath = SH_ALLOC(i+ 1);
+	  sl_strlcpy(linkpath, buf->linkpath, i+1);
 	} 
       else 
@@ -1339,6 +2025,5 @@
 	  linkpath = SH_ALLOC(KEY_LEN + 1);
 	  sl_strlcpy(linkpath, 
-		     sh_tiger_hash (buf->link_path, TIGER_DATA, len,
-				    hashbuf, sizeof(hashbuf)), 
+		     sh_tiger_hash (buf->linkpath, TIGER_DATA, i), 
 		     KEY_LEN+1);
 	}
@@ -1359,10 +2044,6 @@
 #endif
 
-#ifndef PRIu64
-#ifdef  HAVE_LONG_32
-#define PRIu64 "llu"
-#else
-#define PRIu64 "lu"
-#endif
+#ifndef PRIi64
+#define PRIi64 "lld"
 #endif
 
@@ -1376,8 +2057,8 @@
 #ifdef SH_USE_XML
   sl_snprintf(form_rval, 80, _("%s%s%s%s%s"), 
-	      _("size_old=\"%"), PRIu64, _("\" size_new=\"%"), PRIu64, "\" ");
+	      _("size_old=\"%"), PRIi64, _("\" size_new=\"%"), PRIi64, "\" ");
 #else
   sl_snprintf(form_rval, 80, _("%s%s%s%s%s"), 
-	      _("size_old=<%"), PRIu64, _(">, size_new=<%"), PRIu64, ">, ");
+	      _("size_old=<%"), PRIi64, _(">, size_new=<%"), PRIi64, ">, ");
 #endif
 
@@ -1396,27 +2077,17 @@
   char * format;
 
-  char * tmp = SH_ALLOC(SH_MSG_BUF);
-  char * msg = SH_ALLOC(SH_MSG_BUF);
+  char * tmp = SH_ALLOC(SH_BUFSIZE);
+  char * msg = SH_ALLOC(SH_BUFSIZE);
 
   tmp[0] = '\0';
   msg[0] = '\0';
 
-  if (report_checkflags != S_FALSE)
-    {
-      if (is_new)
-	format = _("checkflags_new=\"0%lo\" ");
-      else
-	format = _("checkflags_old=\"0%lo\" ");
-      sl_snprintf(tmp, SH_MSG_BUF, format,
-		  (unsigned long) theFile->check_flags);
-      sl_strlcat(msg, tmp, SH_MSG_BUF); 
-    }
-
-#if defined(__linux__) || defined(HAVE_STAT_FLAGS)
+
+#if defined(__linux__)
   if (is_new)
     format = _("mode_new=\"%s\" attr_new=\"%s\" imode_new=\"%ld\" iattr_new=\"%ld\" ");
   else 
     format = _("mode_old=\"%s\" attr_old=\"%s\" imode_old=\"%ld\" iattr_old=\"%ld\" ");
-  sl_snprintf(tmp, SH_MSG_BUF, format,
+  sl_snprintf(tmp, SH_BUFSIZE, format,
 	      theFile->c_mode,
 	      theFile->c_attributes,
@@ -1430,48 +2101,34 @@
     format = _("mode_old=\"%s\" imode_old=\"%ld\" ");
 
-  sl_snprintf(tmp, SH_MSG_BUF, format,
+  sl_snprintf(tmp, SH_BUFSIZE, format,
 	      theFile->c_mode,
 	      (long) theFile->mode
 	      );
 #endif
-  sl_strlcat(msg, tmp, SH_MSG_BUF);
+  sl_strlcat(msg, tmp, SH_BUFSIZE);
 
   if (is_new)
-    format = _("hardlinks_new=\"%lu\" ");
-  else
-    format = _("hardlinks_old=\"%lu\" ");
-  sl_snprintf(tmp, SH_MSG_BUF, format,
+    format = _("hardlinks_new=\"%ld\" ");
+  else
+    format = _("hardlinks_old=\"%ld\" ");
+  sl_snprintf(tmp, SH_BUFSIZE, format,
 	      (unsigned long) theFile->hardlinks);
-  sl_strlcat(msg, tmp, SH_MSG_BUF); 
+  sl_strlcat(msg, tmp, SH_BUFSIZE); 
 
 
   if (is_new)
-    format = _("idevice_new=\"%lu\" ");
-  else
-    format = _("idevice_old=\"%lu\" ");
-  sl_snprintf(tmp, SH_MSG_BUF, format, (unsigned long) theFile->rdev);
-  sl_strlcat(msg, tmp, SH_MSG_BUF); 
+    format = _("idevice_new=\"%ld\" ");
+  else
+    format = _("idevice_old=\"%ld\" ");
+  sl_snprintf(tmp, SH_BUFSIZE, format, (unsigned long) theFile->rdev);
+  sl_strlcat(msg, tmp, SH_BUFSIZE); 
 
 
   if (is_new)
-    format = _("inode_new=\"%lu\" ");
-  else
-    format = _("inode_old=\"%lu\" ");
-  sl_snprintf(tmp, SH_MSG_BUF, format, (unsigned long) theFile->ino);
-  sl_strlcat(msg, tmp, SH_MSG_BUF); 
-
-  /* 
-   * also report device for prelude
-   */
-#if defined(HAVE_LIBPRELUDE)
-  if (is_new)
-    format = _("dev_new=\"%lu,%lu\" ");
-  else
-    format = _("dev_old=\"%lu,%lu\" ");
-  sl_snprintf(tmp, SH_MSG_BUF, format,		      
-	      (unsigned long) major(theFile->dev),
-	      (unsigned long) minor(theFile->dev));
-  sl_strlcat(msg, tmp, SH_MSG_BUF);
-#endif
+    format = _("inode_new=\"%ld\" ");
+  else
+    format = _("inode_old=\"%ld\" ");
+  sl_snprintf(tmp, SH_BUFSIZE, format, (unsigned long) theFile->ino);
+  sl_strlcat(msg, tmp, SH_BUFSIZE); 
 
 
@@ -1480,7 +2137,7 @@
   else
     format = _("owner_old=\"%s\" iowner_old=\"%ld\" ");
-  sl_snprintf(tmp, SH_MSG_BUF, format,
+  sl_snprintf(tmp, SH_BUFSIZE, format,
 	      theFile->c_owner, (long) theFile->owner);
-  sl_strlcat(msg, tmp, SH_MSG_BUF); 
+  sl_strlcat(msg, tmp, SH_BUFSIZE); 
 
 
@@ -1489,74 +2146,58 @@
   else
     format = _("group_old=\"%s\" igroup_old=\"%ld\" ");
-  sl_snprintf(tmp, SH_MSG_BUF, format,
+  sl_snprintf(tmp, SH_BUFSIZE, format,
 	      theFile->c_group, (long) theFile->group);
-  sl_strlcat(msg, tmp, SH_MSG_BUF); 
+  sl_strlcat(msg, tmp, SH_BUFSIZE); 
 
 
   if (is_new)
-    sl_snprintf(tmp, SH_MSG_BUF, sh_hash_size_format(),
+    sl_snprintf(tmp, SH_BUFSIZE, sh_hash_size_format(),
 		(UINT64) 0, (UINT64) theFile->size);
   else
-    sl_snprintf(tmp, SH_MSG_BUF, sh_hash_size_format(),
+    sl_snprintf(tmp, SH_BUFSIZE, sh_hash_size_format(),
 		(UINT64) theFile->size, (UINT64) 0);
-  sl_strlcat(msg, tmp, SH_MSG_BUF); 
-
-
-  (void) sh_unix_gmttime (theFile->ctime, timstr1c,  sizeof(timstr1c));
+  sl_strlcat(msg, tmp, SH_BUFSIZE); 
+
+
+  sl_strlcpy (timstr1c, sh_unix_gmttime (theFile->ctime),   32);
   if (is_new)
-    sl_snprintf(tmp, SH_MSG_BUF, _("ctime_new=\"%s\" "), timstr1c);
-  else
-    sl_snprintf(tmp, SH_MSG_BUF, _("ctime_old=\"%s\" "), timstr1c);
-  sl_strlcat(msg, tmp, SH_MSG_BUF); 
-
-  (void) sh_unix_gmttime (theFile->atime, timstr1a,  sizeof(timstr1a));
+    sl_snprintf(tmp, SH_BUFSIZE, _("ctime_new=\"%s\" "), timstr1c);
+  else
+    sl_snprintf(tmp, SH_BUFSIZE, _("ctime_old=\"%s\" "), timstr1c);
+  sl_strlcat(msg, tmp, SH_BUFSIZE); 
+
+  sl_strlcpy (timstr1a, sh_unix_gmttime (theFile->atime),   32);
   if (is_new)
-    sl_snprintf(tmp, SH_MSG_BUF, _("atime_new=\"%s\" "), timstr1a);
-  else
-    sl_snprintf(tmp, SH_MSG_BUF, _("atime_old=\"%s\" "), timstr1a);
-  sl_strlcat(msg, tmp, SH_MSG_BUF); 
-
-  (void) sh_unix_gmttime (theFile->mtime, timstr1m,  sizeof(timstr1m));
+    sl_snprintf(tmp, SH_BUFSIZE, _("atime_new=\"%s\" "), timstr1a);
+  else
+    sl_snprintf(tmp, SH_BUFSIZE, _("atime_old=\"%s\" "), timstr1a);
+  sl_strlcat(msg, tmp, SH_BUFSIZE); 
+
+  sl_strlcpy (timstr1m, sh_unix_gmttime (theFile->mtime),   32);
   if (is_new)
-    sl_snprintf(tmp, SH_MSG_BUF, _("mtime_new=\"%s\" "), timstr1m);
-  else
-    sl_snprintf(tmp, SH_MSG_BUF, _("mtime_old=\"%s\" "), timstr1m);
-  sl_strlcat(msg, tmp, SH_MSG_BUF); 
+    sl_snprintf(tmp, SH_BUFSIZE, _("mtime_new=\"%s\" "), timstr1m);
+  else
+    sl_snprintf(tmp, SH_BUFSIZE, _("mtime_old=\"%s\" "), timstr1m);
+  sl_strlcat(msg, tmp, SH_BUFSIZE); 
 
   if (is_new)
-    sl_snprintf(tmp, SH_MSG_BUF, _("chksum_new=\"%s\" "), fileHash);
-  else
-    sl_snprintf(tmp, SH_MSG_BUF, _("chksum_old=\"%s\" "), fileHash);
-  sl_strlcat(msg, tmp, SH_MSG_BUF); 
-
-  if (theFile->c_mode[0] == 'l' || 
-      (theFile->link_path != NULL && theFile->link_path[0] != '-'))
-    {
-      tmp_lnk     = sh_util_safe_name(theFile->link_path);
+    sl_snprintf(tmp, SH_BUFSIZE, _("chksum_new=\"%s\" "), fileHash);
+  else
+    sl_snprintf(tmp, SH_BUFSIZE, _("chksum_old=\"%s\" "), fileHash);
+  sl_strlcat(msg, tmp, SH_BUFSIZE); 
+
+  if (theFile->c_mode[0] == 'l')
+    {
+      tmp_lnk     = sh_util_safe_name(theFile->linkpath);
       if (tmp_lnk)
 	{
 	  if (is_new)
-	    sl_snprintf(tmp, SH_MSG_BUF, _("link_new=\"%s\" "), tmp_lnk);
+	    sl_snprintf(tmp, SH_BUFSIZE, _("link_new=\"%s\" "), tmp_lnk);
 	  else
-	    sl_snprintf(tmp, SH_MSG_BUF, _("link_old=\"%s\" "), tmp_lnk);
+	    sl_snprintf(tmp, SH_BUFSIZE, _("link_old=\"%s\" "), tmp_lnk);
 	  SH_FREE(tmp_lnk);
-	  sl_strlcat(msg, tmp, SH_MSG_BUF);
+	  sl_strlcat(msg, tmp, SH_BUFSIZE);
 	} 
     }
-
-  if (theFile->attr_string)
-    {
-      tmp_lnk     = sh_util_safe_name(theFile->attr_string);
-      if (tmp_lnk)
-	{
-	  if (is_new)
-	    sl_snprintf(tmp, SH_MSG_BUF, _("acl_new=\"%s\" "), tmp_lnk);
-	  else
-	    sl_snprintf(tmp, SH_MSG_BUF, _("acl_old=\"%s\" "), tmp_lnk);
-	  SH_FREE(tmp_lnk);
-	  sl_strlcat(msg, tmp, SH_MSG_BUF);
-	} 
-    }
-
   
   SH_FREE(tmp);
@@ -1573,28 +2214,17 @@
   char * format;
 
-  char * tmp = SH_ALLOC(SH_MSG_BUF);
-  char * msg = SH_ALLOC(SH_MSG_BUF);
+  char * tmp = SH_ALLOC(SH_BUFSIZE);
+  char * msg = SH_ALLOC(SH_BUFSIZE);
 
   tmp[0] = '\0';
   msg[0] = '\0';
 
-  if (report_checkflags == S_TRUE)
-    {
-      if (is_new)
-	format = _("checkflags_new=<0%lo> ");
-      else
-	format = _("checkflags_old=<0%lo> ");
-      sl_snprintf(tmp, SH_MSG_BUF, format,
-		  (unsigned long) theFile->check_flags);
-      sl_strlcat(msg, tmp, SH_MSG_BUF); 
-    }
-
-
-#if defined(__linux__) || defined(HAVE_STAT_FLAGS)
+
+#if defined(__linux__)
   if (is_new)
     format = _("mode_new=<%s>, attr_new=<%s>, imode_new=<%ld>, iattr_new=<%ld>, ");
   else 
     format = _("mode_old=<%s>, attr_old=<%s>, imode_old=<%ld>, iattr_old=<%ld>, ");
-  sl_snprintf(tmp, SH_MSG_BUF, format,
+  sl_snprintf(tmp, SH_BUFSIZE, format,
 	      theFile->c_mode,
 	      theFile->c_attributes,
@@ -1608,49 +2238,35 @@
     format = _("mode_old=<%s>, imode_old=<%ld>, ");
 
-  sl_snprintf(tmp, SH_MSG_BUF, format,
+  sl_snprintf(tmp, SH_BUFSIZE, format,
 	      theFile->c_mode,
 	      (long) theFile->mode
 	      );
 #endif
-  sl_strlcat(msg, tmp, SH_MSG_BUF);
+  sl_strlcat(msg, tmp, SH_BUFSIZE);
 
   if (is_new)
-    format = _("hardlinks_new=<%lu>, ");
-  else
-    format = _("hardlinks_old=<%lu>, ");
-  sl_snprintf(tmp, SH_MSG_BUF, format,
+    format = _("hardlinks_new=<%ld>, ");
+  else
+    format = _("hardlinks_old=<%ld>, ");
+  sl_snprintf(tmp, SH_BUFSIZE, format,
 	      (unsigned long) theFile->hardlinks);
-  sl_strlcat(msg, tmp, SH_MSG_BUF); 
+  sl_strlcat(msg, tmp, SH_BUFSIZE); 
 
 
   if (is_new)
-    format = _("idevice_new=<%lu>, ");
-  else
-    format = _("idevice_old=<%lu>, ");
-  sl_snprintf(tmp, SH_MSG_BUF, format, (unsigned long) theFile->rdev);
-  sl_strlcat(msg, tmp, SH_MSG_BUF); 
+    format = _("idevice_new=<%ld>, ");
+  else
+    format = _("idevice_old=<%ld>, ");
+  sl_snprintf(tmp, SH_BUFSIZE, format, (unsigned long) theFile->rdev);
+  sl_strlcat(msg, tmp, SH_BUFSIZE); 
 
 
   if (is_new)
-    format = _("inode_new=<%lu>, ");
-  else
-    format = _("inode_old=<%lu>, ");
-  sl_snprintf(tmp, SH_MSG_BUF, format, (unsigned long) theFile->ino);
-  sl_strlcat(msg, tmp, SH_MSG_BUF); 
-
-
-  /* 
-   * also report device for prelude
-   */
-#if defined(HAVE_LIBPRELUDE)
-  if (is_new)
-    format = _("dev_new=<%lu,%lu>, ");
-  else
-    format = _("dev_old=<%lu,%lu>, ");
-  sl_snprintf(tmp, SH_MSG_BUF, format,		      
-	      (unsigned long) major(theFile->dev),
-	      (unsigned long) minor(theFile->dev));
-  sl_strlcat(msg, tmp, SH_MSG_BUF);
-#endif
+    format = _("inode_new=<%ld>, ");
+  else
+    format = _("inode_old=<%ld>, ");
+  sl_snprintf(tmp, SH_BUFSIZE, format, (unsigned long) theFile->ino);
+  sl_strlcat(msg, tmp, SH_BUFSIZE); 
+
 
   if (is_new)
@@ -1658,7 +2274,7 @@
   else
     format = _("owner_old=<%s>, iowner_old=<%ld>, ");
-  sl_snprintf(tmp, SH_MSG_BUF, format,
+  sl_snprintf(tmp, SH_BUFSIZE, format,
 	      theFile->c_owner, (long) theFile->owner);
-  sl_strlcat(msg, tmp, SH_MSG_BUF); 
+  sl_strlcat(msg, tmp, SH_BUFSIZE); 
 
 
@@ -1667,74 +2283,59 @@
   else
     format = _("group_old=<%s>, igroup_old=<%ld>, ");
-  sl_snprintf(tmp, SH_MSG_BUF, format,
+  sl_snprintf(tmp, SH_BUFSIZE, format,
 	      theFile->c_group, (long) theFile->group);
-  sl_strlcat(msg, tmp, SH_MSG_BUF); 
+  sl_strlcat(msg, tmp, SH_BUFSIZE); 
 
 
   if (is_new)
-    sl_snprintf(tmp, SH_MSG_BUF, sh_hash_size_format(),
+    sl_snprintf(tmp, SH_BUFSIZE, sh_hash_size_format(),
 		(UINT64) 0, (UINT64) theFile->size);
   else
-    sl_snprintf(tmp, SH_MSG_BUF, sh_hash_size_format(),
+    sl_snprintf(tmp, SH_BUFSIZE, sh_hash_size_format(),
 		(UINT64) theFile->size, (UINT64) 0);
-  sl_strlcat(msg, tmp, SH_MSG_BUF); 
-
-
-  (void) sh_unix_gmttime (theFile->ctime, timstr1c,  sizeof(timstr1c));
+  sl_strlcat(msg, tmp, SH_BUFSIZE); 
+
+
+  sl_strlcpy (timstr1c, sh_unix_gmttime (theFile->ctime),   32);
   if (is_new)
-    sl_snprintf(tmp, SH_MSG_BUF, _("ctime_new=<%s>, "), timstr1c);
-  else
-    sl_snprintf(tmp, SH_MSG_BUF, _("ctime_old=<%s>, "), timstr1c);
-  sl_strlcat(msg, tmp, SH_MSG_BUF); 
-
-  (void) sh_unix_gmttime (theFile->atime, timstr1a,  sizeof(timstr1a));
+    sl_snprintf(tmp, SH_BUFSIZE, _("ctime_new=<%s>, "), timstr1c);
+  else
+    sl_snprintf(tmp, SH_BUFSIZE, _("ctime_old=<%s>, "), timstr1c);
+  sl_strlcat(msg, tmp, SH_BUFSIZE); 
+
+  sl_strlcpy (timstr1a, sh_unix_gmttime (theFile->atime),   32);
   if (is_new)
-    sl_snprintf(tmp, SH_MSG_BUF, _("atime_new=<%s>, "), timstr1a);
-  else
-    sl_snprintf(tmp, SH_MSG_BUF, _("atime_old=<%s>, "), timstr1a);
-  sl_strlcat(msg, tmp, SH_MSG_BUF); 
-
-  (void) sh_unix_gmttime (theFile->mtime, timstr1m,  sizeof(timstr1m));
+    sl_snprintf(tmp, SH_BUFSIZE, _("atime_new=<%s>, "), timstr1a);
+  else
+    sl_snprintf(tmp, SH_BUFSIZE, _("atime_old=<%s>, "), timstr1a);
+  sl_strlcat(msg, tmp, SH_BUFSIZE); 
+
+  sl_strlcpy (timstr1m, sh_unix_gmttime (theFile->mtime),   32);
   if (is_new)
-    sl_snprintf(tmp, SH_MSG_BUF, _("mtime_new=<%s>, "), timstr1m);
-  else
-    sl_snprintf(tmp, SH_MSG_BUF, _("mtime_old=<%s>, "), timstr1m);
-  sl_strlcat(msg, tmp, SH_MSG_BUF); 
+    sl_snprintf(tmp, SH_BUFSIZE, _("mtime_new=<%s>, "), timstr1m);
+  else
+    sl_snprintf(tmp, SH_BUFSIZE, _("mtime_old=<%s>, "), timstr1m);
+  sl_strlcat(msg, tmp, SH_BUFSIZE); 
 
   if (is_new)
-    sl_snprintf(tmp, SH_MSG_BUF, _("chksum_new=<%s>"), fileHash);
-  else
-    sl_snprintf(tmp, SH_MSG_BUF, _("chksum_old=<%s>"), fileHash);
-  sl_strlcat(msg, tmp, SH_MSG_BUF); 
-
-  if (theFile->c_mode[0] == 'l' || 
-      (theFile->link_path != NULL && theFile->link_path[0] != '-'))
-    {
-      tmp_lnk     = sh_util_safe_name(theFile->link_path);
+    sl_snprintf(tmp, SH_BUFSIZE, _("chksum_new=<%s>"), fileHash);
+  else
+    sl_snprintf(tmp, SH_BUFSIZE, _("chksum_old=<%s>"), fileHash);
+  sl_strlcat(msg, tmp, SH_BUFSIZE); 
+
+  if (theFile->c_mode[0] == 'l')
+    {
+      tmp_lnk     = sh_util_safe_name(theFile->linkpath);
       if (tmp_lnk)
 	{
 	  if (is_new)
-	    sl_snprintf(tmp, SH_MSG_BUF, _(", link_new=<%s> "), tmp_lnk);
+	    sl_snprintf(tmp, SH_BUFSIZE, _(", link_new=<%s> "), tmp_lnk);
 	  else
-	    sl_snprintf(tmp, SH_MSG_BUF, _(", link_old=<%s> "), tmp_lnk);
+	    sl_snprintf(tmp, SH_BUFSIZE, _(", link_old=<%s> "), tmp_lnk);
 	  SH_FREE(tmp_lnk);
-	  sl_strlcat(msg, tmp, SH_MSG_BUF);
+	  sl_strlcat(msg, tmp, SH_BUFSIZE);
 	} 
     }
   
-  if (theFile->attr_string)
-    {
-      tmp_lnk     = sh_util_safe_name(theFile->attr_string);
-      if (tmp_lnk)
-	{
-	  if (is_new)
-	    sl_snprintf(tmp, SH_MSG_BUF, _(", acl_new=<%s> "), tmp_lnk);
-	  else
-	    sl_snprintf(tmp, SH_MSG_BUF, _(", acl_old=<%s> "), tmp_lnk);
-	  SH_FREE(tmp_lnk);
-	  sl_strlcat(msg, tmp, SH_MSG_BUF);
-	} 
-    }
-
   SH_FREE(tmp);
   return (msg);
@@ -1751,8 +2352,6 @@
   if (p) 
     {
-      SH_MUTEX_LOCK(mutex_hash);
-      hashinsert (tab, p);
-      p->modi_mask = theFile->check_flags;
-      SH_MUTEX_UNLOCK(mutex_hash);
+      hashinsert (p);
+      p->modi_mask = theFile->check_mask;
     }
 
@@ -1760,108 +2359,4 @@
 }
 
-int sh_hash_is_null_file(file_type * theFile)
-{
-  if (theFile->hardlinks == SH_DEADFILE && theFile->mode  == 0 &&
-      theFile->ino == 0                 && theFile->ctime == 0)
-    {
-      return S_TRUE;
-    }
-  return S_FALSE;
-}
-
-int sh_hash_is_null_record(sh_filestore_t * theFile)
-{
-  if (theFile->hardlinks == SH_DEADFILE && theFile->mode  == 0 &&
-      theFile->ino == 0                 && theFile->ctime == 0)
-    {
-      return S_TRUE;
-    }
-  return S_FALSE;
-}
-
-void sh_hash_insert_null(char * str)
-{
-  file_type theFile = { 0, 0, {'\0'}, 0, 0, 0, 0, 0, 
-#if defined(__linux__) || defined(HAVE_STAT_FLAGS)
-			0, {'\0'},
-#endif
-			{'\0'}, 0, {'\0'}, 0, {'\0'}, 
-			0, 0, 0, 0, 0, 0, 0, NULL,  0, {'\0'}, 0, NULL
-  }; /* clang compiler bails out on standard conforming init with just {0} */
-  char      fileHash[KEY_LEN+1];
-  char      hashbuf[KEYBUF_SIZE];
-
-  sl_strlcpy(fileHash, SH_KEY_NULL, sizeof(fileHash));
-  theFile.hardlinks = SH_DEADFILE;
-
-  if (sl_strlen(str) < PATH_MAX)
-    sl_strlcpy(theFile.fullpath, str, PATH_MAX);
-  else 
-     sl_strlcpy(theFile.fullpath, 
-		sh_tiger_hash(str, TIGER_DATA, sl_strlen(str),
-			      hashbuf, sizeof(hashbuf)),
-		PATH_MAX);
-
-  sh_hash_pushdata_memory(&theFile, fileHash);
-  return;
-}
-
-static int handle_notfound(int  log_severity, int class,
-			   file_type * theFile, char * fileHash)
-{
-  sh_file_t * p;
-  int         retval = 0;
-
-  if (!theFile)
-    return retval;
-  
-  if (S_FALSE == sh_ignore_chk_new(theFile->fullpath))
-    {
-      char * tmp = sh_util_safe_name(theFile->fullpath);
-      char * str;
-
-      sh_files_fixup_mask(class, &(theFile->check_flags));
-      str = all_items (theFile, fileHash, 1);
-      
-      if (!sh_global_check_silent)
-	sh_error_handle (log_severity, FIL__, __LINE__, 0, 
-			 MSG_FI_ADD2, 
-			 tmp, str);
-      ++sh.statistics.files_report;
-      SH_FREE(str);
-      SH_FREE(tmp);
-    }
-  
-  if (sh.flag.reportonce == S_TRUE)
-    SET_SH_FFLAG_REPORTED(theFile->file_reported);
-  
-  if (sh.flag.reportonce == S_TRUE && sh.flag.update == S_FALSE)
-    {
-      p = sh_hash_push_int(theFile, fileHash);
-      if (p)
-	{
-	  hashinsert (tab, p);
-	  p->modi_mask = theFile->check_flags;
-	  p->theFile.checkflags = p->modi_mask;
-	}
-    }
-  
-  else if (S_TRUE == sh.flag.update)
-    {
-      if (S_TRUE == sh_util_ask_update (theFile->fullpath))
-	{
-	  p = sh_hash_push_int(theFile, fileHash);
-	  if (p)
-	    {
-	      hashinsert (tab, p);
-	      p->modi_mask = theFile->check_flags;
-	      p->theFile.checkflags = p->modi_mask;
-	    }
-	}
-      else
-	retval = 1;
-    }
-  return retval;
-}
 
 /*****************************************************************
@@ -1879,4 +2374,6 @@
   char * tmp_lnk;
   char * tmp_lnk_old;
+
+  char * str;
 
   char timstr1c[32];
@@ -1887,29 +2384,17 @@
   char timstr2m[32];
   char linkHash[KEY_LEN+1];
-  char * linkComp;
   int  maxcomp;
-  volatile int  checksum_flag = 0;
 
   char change_code[16];
   int  i;
 
-  unsigned long modi_mask;
+  unsigned long modi_mask = 0;
 
   char log_policy[32];
-  volatile int  log_severity;
-  char hashbuf[KEYBUF_SIZE];
-  struct {
-    unsigned long oldflags;
-    unsigned long newflags;
-  } cf_report;
-
-  int  retval;
+  int  log_severity;
 
   SL_ENTER(_("sh_hash_compdata"));
 
-  if (!theFile)
-    SL_RETURN(0, _("sh_hash_compdata"));
-
- if (IsInit != 1) sh_hash_init();
+  if (IsInit != 1) sh_hash_init();
 
   if (severity_override < 0)
@@ -1922,9 +2407,4 @@
 
   /* --------  find the entry for the file ----------------       */
-
-  SH_MUTEX_LOCK(mutex_hash);
-
-  modi_mask = 0;
-  retval    = 0;
 
   if (sl_strlen(theFile->fullpath) <= MAX_PATH_STORE) 
@@ -1933,6 +2413,5 @@
     p = hashsearch( sh_tiger_hash(theFile->fullpath, 
 				  TIGER_DATA, 
-				  sl_strlen(theFile->fullpath),
-				  hashbuf, sizeof(hashbuf))
+				  sl_strlen(theFile->fullpath))
 		    );
 
@@ -1943,24 +2422,44 @@
   if (p == NULL) 
     {
-      retval = handle_notfound(log_severity, class, theFile, fileHash);
-      goto unlock_and_return;
-    }
-
-  /* ---------  Skip if we don't want to report changes. ------------
-   */
-  
-  if (S_TRUE == sh_ignore_chk_mod(theFile->fullpath))
-    {
-      MODI_SET(theFile->check_flags, MODI_NOCHECK);
-      p->modi_mask = theFile->check_flags;
-      p->theFile.checkflags = p->modi_mask;
-      goto unlock_and_return;
-    }
-
-  cf_report.oldflags = p->theFile.checkflags;
-  cf_report.newflags = theFile->check_flags;
-
-  p->modi_mask = theFile->check_flags;
-  p->theFile.checkflags = p->modi_mask;
+      if (sh.flag.reportonce == S_TRUE)
+	{
+	  p = sh_hash_push_int(theFile, fileHash);
+	  hashinsert (p);
+	  if (p)
+	    p->modi_mask = theFile->check_mask;
+
+	}
+
+      if (S_FALSE == sh_ignore_chk_new(theFile->fullpath))
+	{
+	  tmp = sh_util_safe_name(theFile->fullpath);
+
+	  str = all_items (theFile, fileHash, 1);
+	  sh_error_handle (log_severity, FIL__, __LINE__, 0, 
+			   MSG_FI_ADD2, 
+			   tmp, str);
+	  SH_FREE(str);
+
+	  SH_FREE(tmp);
+	}
+
+      if (p)
+	p->visited   = S_TRUE;
+      if (sh.flag.reportonce == S_TRUE)
+	theFile->reported = S_TRUE;
+	
+      if (sh.flag.isdaemon == S_FALSE && sh.flag.update == S_TRUE )
+	{
+	  if (S_FALSE == sh_util_ask_update (theFile->fullpath))
+	    {
+	      SL_RETURN(1, _("sh_hash_compdata"));
+	    } 
+	}
+      SL_RETURN(0, _("sh_hash_compdata"));
+    }
+  else
+    {
+      p->modi_mask = theFile->check_mask;
+    }
 
   /* initialize change_code */
@@ -1972,81 +2471,37 @@
 	theFile->fullpath, fileHash, p->theFile.checksum));
 
-  if ( (fileHash != NULL) &&
-       (strncmp (fileHash, p->theFile.checksum, KEY_LEN) != 0) && 
-       (theFile->check_flags & MODI_CHK) != 0)
-    {
-      checksum_flag = 1;
-      
-      if ((theFile->check_flags & MODI_SGROW) == 0)
-	{
-	  modi_mask |= MODI_CHK;
-	  change_code[0] = 'C';
-	  TPT ((0, FIL__, __LINE__, _("mod=<checksum>")));
-	}
-      else
-	{
-	  if (0 != strncmp (&fileHash[KEY_LEN + 1], p->theFile.checksum, KEY_LEN))
-	    {
-	      if (S_FALSE == sh_check_rotated_log (theFile->fullpath, (UINT64) p->theFile.size, 
-						   (UINT64) p->theFile.ino, p->theFile.checksum,
-						   p->theFile.checkflags))
-		{
-		  modi_mask |= MODI_CHK;
-		  change_code[0] = 'C';
-		  TPT ((0, FIL__, __LINE__, _("mod=<checksum>")));
-		}
-	      else
-		{
-		  /* logfile has been rotated */
-		  p->theFile.size  = theFile->size;
-		  p->theFile.ino   = theFile->ino;
-		  sl_strlcpy(p->theFile.checksum, fileHash, KEY_LEN+1);
-		}
-	    }
-	  else
-	    {
-	      p->theFile.size  = theFile->size;
-	      sl_strlcpy(p->theFile.checksum, fileHash, KEY_LEN+1);
-	    }
-	}
+  if ( (fileHash != NULL) && (p->theFile.checksum != NULL)   && 
+       (strncmp (fileHash, p->theFile.checksum, 50) != 0) && 
+       (theFile->check_mask & MODI_CHK) != 0)
+    {
+      modi_mask |= MODI_CHK;
+      change_code[0] = 'C';
+      TPT ((0, FIL__, __LINE__, _("mod=<checksum>")));
     } 
 
   if (p->theFile.c_mode[0] == 'l') 
     {
-      if (!(theFile->link_path) &&
-	  (theFile->check_flags & MODI_LNK) != 0)
-	{
-	  linkComp = NULL;
-	  modi_mask |= MODI_LNK;
-	  change_code[1] = 'L';
-	  TPT ((0, FIL__, __LINE__, _("mod=<link>")));
-	}
-      else
-	{
-	  if (sl_strlen(theFile->link_path) >= MAX_PATH_STORE) 
-	    {
-	      sl_strlcpy(linkHash, 
-			 sh_tiger_hash(theFile->link_path, 
-				       TIGER_DATA,
-				       sl_strlen(theFile->link_path),
-				       hashbuf, sizeof(hashbuf)), 
-			 sizeof(linkHash));
-	      linkComp = linkHash;
-	      maxcomp  = KEY_LEN;
-	    } 
-	  else 
-	    {
-	      linkComp = theFile->link_path;
-	      maxcomp  = MAX_PATH_STORE;
-	    }
-	  
-	  if ( sl_strncmp (linkComp, p->linkpath, maxcomp) != 0 &&
-	       (theFile->check_flags & MODI_LNK) != 0)
-	    {
-	      modi_mask |= MODI_LNK;
-	      change_code[1] = 'L';
-	      TPT ((0, FIL__, __LINE__, _("mod=<link>")));
-	    } 
-	}
+      if (sl_strlen(theFile->linkpath) >= MAX_PATH_STORE) 
+	{
+	  sl_strlcpy(linkHash, 
+		     sh_tiger_hash(theFile->linkpath, 
+				   TIGER_DATA,
+				   sl_strlen(theFile->linkpath)), 
+		     MAX_PATH_STORE+1);
+	  maxcomp = MAX_PATH_STORE;
+	} 
+      else 
+	{
+	  sl_strlcpy(linkHash, theFile->linkpath, KEY_LEN + 1);
+	  maxcomp = KEY_LEN;
+	}
+
+    if ( sl_strncmp (linkHash, p->linkpath, maxcomp) != 0 &&
+	 (theFile->check_mask & MODI_LNK) != 0)
+      {
+	modi_mask |= MODI_LNK;
+	change_code[1] = 'L';
+	TPT ((0, FIL__, __LINE__, _("mod=<link>")));
+      } 
     }
 
@@ -2055,5 +2510,5 @@
       if ( ( major(theFile->rdev) != major((dev_t)p->theFile.rdev) || 
 	     minor(theFile->rdev) != minor((dev_t)p->theFile.rdev) ) &&
-	   (theFile->check_flags & MODI_RDEV) != 0)
+	   (theFile->check_mask & MODI_RDEV) != 0)
 	{
 	  modi_mask |= MODI_RDEV;
@@ -2066,45 +2521,13 @@
    */
   if ( (UINT32) theFile->ino != (UINT32) p->theFile.ino  &&
-       (theFile->check_flags & MODI_INO) != 0)
-    {
-      if ((theFile->check_flags & MODI_SGROW) == 0)
-	{
-	  modi_mask |= MODI_INO;
-	  change_code[3] = 'I';
-	  TPT ((0, FIL__, __LINE__, _("mod=<inode>")));
-	}
-      else
-	{
-	  /* growing log, checksum ok but inode changed 
-	   */
-	  if (checksum_flag == 0)
-	    {
-	      if (S_FALSE == sh_check_rotated_log (theFile->fullpath, (UINT64) p->theFile.size, 
-						   (UINT64) p->theFile.ino, p->theFile.checksum,
-						   p->theFile.checkflags))
-		{
-		  modi_mask |= MODI_INO;
-		  change_code[3] = 'I';
-		  TPT ((0, FIL__, __LINE__, _("mod=<inode>")));
-		}
-	      else
-		{
-		  /* logfile has been rotated */
-		  p->theFile.size  = theFile->size;
-		  p->theFile.ino   = theFile->ino;
-		  sl_strlcpy(p->theFile.checksum, fileHash, KEY_LEN+1);
-		}
-	    }
-	  else
-	    {
-	      modi_mask |= MODI_INO;
-	      change_code[3] = 'I';
-	      TPT ((0, FIL__, __LINE__, _("mod=<inode>")));
-	    }
-	}
+       (theFile->check_mask & MODI_INO) != 0)
+    {
+      modi_mask |= MODI_INO;
+      change_code[3] = 'I';
+      TPT ((0, FIL__, __LINE__, _("mod=<inode>")));
     } 
     
   if ( theFile->hardlinks != (nlink_t) p->theFile.hardlinks &&
-       (theFile->check_flags & MODI_HLN) != 0)
+       (theFile->check_mask & MODI_HLN) != 0)
     {
       modi_mask |= MODI_HLN;
@@ -2115,18 +2538,9 @@
 
   if ( (  (theFile->mode != p->theFile.mode)
-#if defined(USE_ACL) || defined(USE_XATTR)
-	  || ( (sh_unix_check_selinux|sh_unix_check_acl) &&
-	       ( 
-		(theFile->attr_string == NULL && p->attr_string != NULL) ||
-		(theFile->attr_string != NULL && p->attr_string == NULL) ||
-		(theFile->attr_string != NULL && 0 != strcmp(theFile->attr_string, p->attr_string))
-		)
-	       )
-#endif
-#if defined(__linux__) || defined(HAVE_STAT_FLAGS)
+#if defined(__linux__)
           || (theFile->attributes != p->theFile.attributes)
 #endif
-	  )
-       && (theFile->check_flags & MODI_MOD) != 0)
+        )
+       && (theFile->check_mask & MODI_MOD) != 0)
     {
       modi_mask |= MODI_MOD;
@@ -2136,5 +2550,5 @@
        * report link path if switch link/no link 
        */
-      if ((theFile->check_flags & MODI_LNK) != 0 &&
+      if ((theFile->check_mask & MODI_LNK) != 0 &&
 	  (theFile->c_mode[0] != p->theFile.c_mode[0]) &&
 	  (theFile->c_mode[0] == 'l' || p->theFile.c_mode[0] == 'l'))
@@ -2147,5 +2561,5 @@
 
   if ( theFile->owner != (uid_t) p->theFile.owner &&
-       (theFile->check_flags & MODI_USR) != 0)
+       (theFile->check_mask & MODI_USR) != 0)
     {
       modi_mask |= MODI_USR;
@@ -2155,5 +2569,5 @@
 
   if ( theFile->group != (gid_t) p->theFile.group &&
-       (theFile->check_flags & MODI_GRP) != 0)
+       (theFile->check_mask & MODI_GRP) != 0)
     {
       modi_mask |= MODI_GRP;
@@ -2164,5 +2578,5 @@
   
   if ( theFile->mtime != (time_t) p->theFile.mtime &&
-       (theFile->check_flags & MODI_MTM) != 0)
+       (theFile->check_mask & MODI_MTM) != 0)
     {
       modi_mask |= MODI_MTM;
